function y=Embedded_block_Encoder(B,subband)
% B is the M x N block

context = struct([]);
tp = [0]; % Truncating points in the bit-stream
delta = 0.5;
% Initialize MQ Encoder
A=hex2dec('8000');
C=0;
tbar=12;
T=dec2hex(0);
L=-1;
%%%%%%%%%%%%%%%%%%%%%%%%
% Initialize context states
for k=0:18
    context(k+1).Sigma = 0;
    if (k==0)
        context(k+1).Sigma = 4;
    else
        if (k==9)
            context(k+1).Sigma = 3;
        else
            if (k==18)
                context(k+1).Sigma = 46;
            end
        end
    end
    
    context(k+1).s = 0;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[M N] = size(B);
v_tmp = 0;
sigma = zeros(M,N);
sigma_ant = zeros(M,N);
ppi = zeros(M,N);

wmax = max(abs(B(:)));
if (wmax > 0)
    K=fix(log2(wmax))+1; % Number of bit-planes needed
else
    K=1;
end

bitStream=[];
% Encode bit-planes p form K-1 to 0
Wup = ones(M,N)*(2^K-1);
%Wdown = -ones(M,N)*(2^K-1);
Wdown = zeros(M,N);
W_rec = zeros(1,M*N);
sgn = sign(B);
D=sum(sum(B.^2))/(M*N);

for p=K-1:-1:0
    bp = mod(fix(abs(B)/2^(p)),2);    
    if (p<K-1)
        [bs,context,sigma,ppi,A,C,T,L,tbar,coded]=MQ_Ecoder_Pass0(bp,sigma,sgn,ppi,context,A,C,T,L,tbar,subband); % Encode pass 0
        if (sum(coded(:)) > 0)
            bitStream = [bitStream bs];
            tp = [tp size(bitStream,2)];
            index=find(coded);
            Wdown(index)=Wdown(index).*(1-bp(index))+(2^p+Wdown(index)).*bp(index);
            Wup(index)=Wup(index).*bp(index)+(Wup(index)-2^p).*(1-bp(index));
            W1=sigma.*sgn.*(fix((Wup+Wdown)/2)+delta);
            dist = sum(sum((W1-B).^2))/(N*M);
            D = [D dist];
            W_rec = [W_rec;reshape(W1,[1 size(W1,1)*size(W1,2)])];
        end
        [bs,context,A,C,T,L,tbar,coded]=MQ_Ecoder_Pass1(bp,sigma,sigma_ant,ppi,context,A,C,T,L,tbar,subband); % Encode pass 1
        if (sum(coded(:)) > 0)
            bitStream = [bitStream bs];
            tp = [tp size(bitStream,2)];
            index=find(coded);
            Wdown(index)=Wdown(index).*(1-bp(index))+(2^p+Wdown(index)).*bp(index);
            Wup(index)=Wup(index).*bp(index)+(Wup(index)-2^p).*(1-bp(index));
            W1=sigma.*sgn.*(fix((Wup+Wdown)/2)+delta);
            dist = sum(sum((W1-B).^2))/(N*M);
            D = [D dist];
            W_rec = [W_rec;reshape(W1,[1 size(W1,1)*size(W1,2)])];
        end
    end
    [bs,context,sigma,A,C,T,L,tbar,coded]=MQ_Ecoder_Pass2(bp,sigma,sgn,ppi,context,A,C,T,L,tbar,subband); % Encode pass 2
    
    if (sum(coded(:)) > 0)
        bitStream = [bitStream bs];
        tp = [tp size(bitStream,2)];
        index=find(coded);
        Wdown(index)=Wdown(index).*(1-bp(index))+(2^p+Wdown(index)).*bp(index);
        Wup(index)=Wup(index).*bp(index)+(Wup(index)-2^p).*(1-bp(index));
        W1=sigma.*sgn.*(fix((Wup+Wdown)/2)+delta);
        dist = sum(sum((W1-B).^2))/(N*M);
        D = [D dist];
        W_rec = [W_rec;reshape(W1,[1 size(W1,1)*size(W1,2)])];
    end
end

tp=tp/2; % Each char has 4 bits

% Determine the convex hull
if (abs(D(1)) > 0)
    if (size(D,2) > 2)
        khull=convhull(tp,D)';
        cont=1;
        while (khull(cont+1)>khull(cont))
         cont = cont +1;
        end
        khull=khull(1:cont);
    else
        khull = [1 size(tp,2)];    
    end
else
    khull = [1 size(tp,2)];
end

% Determine the slopes Rate-Distortion
%slope = (distortion(1:end-1) - distortion(2:end))./(tp(1:end-1) - tp(2:end));
slope = (D(khull(1:end-1)) - D(khull(2:end)))./(tp(khull(1:end-1)) - tp(khull(2:end)));
%figure;plot(slope,'*-');
%figure;plot(tp,D,'bo-');hold on;plot(tp(khull),D(khull),'r*-');

y.B=K;
y.bs = bs;
y.R = tp(khull);
y.D = D(khull);
y.K = khull;
y.slope = slope;
y.wRec=W_rec(khull,:);
