function [bs,context,A,C,T,L,tbar]=MQ_Encode(x,k,context,A,C,T,L,tbar)

% x is the symbol to encode
% context(k) is the context for the symbol x

k=k+1; % To acces the table the index must start at 1, not at zero

[Sigma,Sigma_mps,Sigma_lps,Xs,pb,p]=findProbStateTrans();
pbar = pb(k);
s = context(k).s;
A=A-pbar;
bs=[];

if (A<pbar)
    s = 1-s;    % Conditional exchange of MPS and LPS
end

if (x==s)
   C = C + pbar; % Assign MPS the upper subinterval
else
    A = pbar;   % Assign LPS the lower subinterval
end

if (A<2^15)
   if (x==context(k).s) 
   % The symbol was a real MPS
        context(k).Sigma=Sigma_mps(context(k).Sigma+1);    
   else
   % The symbol was a real LPS
        if (Xs(context(k).Sigma+1)==1)
           context(k).s = 1-context(k).s; % Switch MPS/LPS 
        end
        context(k).Sigma=Sigma_lps(context(k).Sigma+1);    
   end
end

while (A < 2^15) % Perform a normalization shift
   A=2*A;
   C=2*C;
   tbar= tbar-1;
   if (tbar==0)
      [bs,T,C,L,tbar]=MQ_Transfer_Byte(T,C,L,tbar); 
   end
end