function y=invBiOrthogonalWavelet79Rows(x,col)

% Compute coefficients for the lifting scheme of the wavelet
a =-1.586134;
b=-0.05298011;
c=0.882911;
d=0.4435068;
K=1.149604398;
%K=1;

[M, N]=size(x);
%y=zeros(M,N);

if (col)
    % Process columns first
    img.Even = x(:,1:N/2)/K; % Even samples of columns
    img.Odd = x(:,N/2+1:N)*K; % Odd samples of columns
    
    % First stage
    y.s1=zeros(M,N/2);
    y.s1 = img.Even - d*(img.Odd+[img.Odd(:,1) img.Odd(:,1:N/2-1)]);
    
    % Second stage
    y.s2 = img.Odd - c*(y.s1+[y.s1(:,2:N/2) y.s1(:,N/2)]);
    
    % Third stage
    y.H = y.s1 - b*(y.s2+[y.s2(:,1) y.s2(:,1:N/2-1)]);
    
    % Fourth stage
    y.L = y.s2 - a*(y.H+[y.H(:,2:N/2) y.H(:,N/2)]); 
    
    y.comp(1:M,1:2:N) = y.H;
    y.comp(1:M,2:2:N) = y.L;    
else
    % Process columns first
    img.Even = x(1:M/2,:)/K; % Even samples of columns
    img.Odd = x(M/2+1:M,:)*K; % Odd samples of columns
    
    % First stage
    y.s1=zeros(M/2,N);
    y.s1 = img.Even - d*(img.Odd+[img.Odd(1,:);img.Odd(1:M/2-1,:)]);
    % Second stage
    y.s2 = img.Odd - c*(y.s1+[y.s1(2:M/2,:);y.s1(M/2,:)]);
    
    % Third stage
    y.H = y.s1 - b*(y.s2+[y.s2(1,:);y.s2(1:M/2-1,:)]);
   
    % Second stage
    y.L = y.s2 - a*(y.H+[y.H(2:M/2,:);y.H(M/2,:)]); 
    
    y.comp(1:2:M,1:N) = y.H;
    y.comp(2:2:M,1:N) = y.L;    
end

% y=invBiOrthogonalWavelet79Rows(x,0); %For Rows
% y=invBiOrthogonalWavelet79Rows(x,1); %For Columns